# Plug-in

Now, one more level of separation.
Let's create an interface for plug-ins.
After that, anything that implements the interface of the plug-in can be loaded by the main program.
Thus, the program features can be extended (as long as the new functionality fits the concept of the plug-in) absolute dynamically, without recompiling any parts of the main program.
Each plug-in will be implemented in the form of a shared object: feature `dothis` will be implemented in the `libdothis.so`, which can be placed in the `LD_LIBRARY_PATH`.
Any features available in the actual `LD_LIBRARY_PATH` can be used.

```sh
make
pushd pnm-main
LD_LIBRARY_PATH=../libpnm:../pnm-plugins:$LD_LIBRARY_PATH ./pnm-main load=../../torony-o.ppm fuzz save=fuzzed.ppm invert=green dcolor=red save=out.pgm
popd
make clean
```
