#include "pnm.h"
#include <string.h>

static void (*deleter_function)(rgbpic_t *) = NULL;

int RGBPIC_PLUGIN_START_FNC(const char *params) {
    if (!strcmp("red", params)) {
        deleter_function = rgbpic_delete_R;
    } else if (!strcmp("green", params)) {
        deleter_function = rgbpic_delete_G;
    } else if (!strcmp("blue", params)) {
        deleter_function = rgbpic_delete_B;
    } else {
        return 1;
    }
    return 0;
}

rgbpic_t* RGBPIC_PLUGIN_WORK_FNC(rgbpic_t *pic) {
    if (deleter_function) {
        deleter_function(pic);
        return pic;
    }
    return NULL;
}

int RGBPIC_PLUGIN_STOP_FNC() {
    return 0;
}
