#include "pnm.h"
#include <string.h>

static void (*gray_function)(rgbpic_t *) = NULL;

int RGBPIC_PLUGIN_START_FNC(const char *params) {
    if (params == NULL || !strcmp("", params) || !strcmp("lum", params)) {
        gray_function = rgbpic_convert_to_grey_lum;
    } else if (!strcmp("nom", params)) {
        gray_function = rgbpic_convert_to_grey_avg;
    } else if (!strcmp("red", params)) {
        gray_function = rgbpic_convert_R_to_grey;
    } else if (!strcmp("green", params)) {
        gray_function = rgbpic_convert_G_to_grey;
    } else if (!strcmp("blue", params)) {
        gray_function = rgbpic_convert_B_to_grey;
    } else if (!strcmp("binarize-lum", params)) {
        gray_function = rgbpic_convert_to_bw_lum;
    } else if (!strcmp("binarize-nom", params)) {
        gray_function = rgbpic_convert_to_bw_avg;
    } else {
        return 1;
    }
    return 0;
}

rgbpic_t* RGBPIC_PLUGIN_WORK_FNC(rgbpic_t *pic) {
    if (gray_function) {
        gray_function(pic);
        return pic;
    }
    return NULL;
}

int RGBPIC_PLUGIN_STOP_FNC() {
    return 0;
}
