#include "pnm.h"
#include <malloc.h>
#include <stdio.h>

int RGBPIC_PLUGIN_START_FNC(const char *params) {
    return 0;
}

rgbpic_t* RGBPIC_PLUGIN_WORK_FNC(rgbpic_t *pic) {
    rgbpic_picture_size_t i, j;
    int szurke = 1, binary = 1;
    unsigned long long int iR = 0, iG = 0, iB = 0;
    printf("A képfájl mérete: %hdx%hd pixel\n", pic->width, pic->height);
    for (i = 0; i < pic->height; ++i) {
        for (j = 0; j < pic->width; ++j) {
            rgbpic_monochrome_pixel_t r, g, b;
            iR += r = pic->pixelvalues[rgbpic_coord(pic, j, i)].red;
            iG += g = pic->pixelvalues[rgbpic_coord(pic, j, i)].green;
            iB += b = pic->pixelvalues[rgbpic_coord(pic, j, i)].blue;
            if (r != g || r != b) {
                szurke = binary = 0;
            }
            if (r != 0 && r != pic->maxpixvalue) {
                binary = 0;
            }
        }
    }
    if (binary) {
        printf("Ez egy fekete-fehér bináris kép %llu%%-os átlagos szürke intenzitással.\n",
                    100llu * iR / (pic->width * pic->height * pic->maxpixvalue));
    } else if (szurke) {
        printf("Ez egy szürkeárnyalatos kép %llu%%-os átlagos intenzitással.\n",
                    100llu * iR / (pic->width * pic->height * pic->maxpixvalue));
    } else {
        printf("Ez egy színes kép (%llu%%, %llu%%, %llu%%)-os átlagos RGB,\n",
                    100llu * iR / (pic->width * pic->height * pic->maxpixvalue),
                    100llu * iG / (pic->width * pic->height * pic->maxpixvalue),
                    100llu * iB / (pic->width * pic->height * pic->maxpixvalue));
        printf("és %llu%%-os érték szerinti valamint %llu%%-os érzékelt szürke intenzitásokkal.\n",
                    100llu * (iR + iG + iB) / (3 * pic->width * pic->height * pic->maxpixvalue),
                    (30*iR + 59*iG + 11*iB) / (pic->width * pic->height * pic->maxpixvalue));
    }
    return pic;
}

int RGBPIC_PLUGIN_STOP_FNC() {
    return 0;
}
