#include "pnm.h"
#include <string.h>

static void (*inverter_function)(rgbpic_t *) = NULL;

int RGBPIC_PLUGIN_START_FNC(const char *params) {
    if (params == NULL || !strcmp("", params) || !strcmp("all", params)) {
        inverter_function = rgbpic_invert;
    } else if (!strcmp("red", params)) {
        inverter_function = rgbpic_invert_R;
    } else if (!strcmp("green", params)) {
        inverter_function = rgbpic_invert_G;
    } else if (!strcmp("blue", params)) {
        inverter_function = rgbpic_invert_B;
    } else {
        return 1;
    }
    return 0;
}

rgbpic_t* RGBPIC_PLUGIN_WORK_FNC(rgbpic_t *pic) {
    if (inverter_function) {
        inverter_function(pic);
        return pic;
    }
    return NULL;
}

int RGBPIC_PLUGIN_STOP_FNC() {
    return 0;
}
