#include "pnm.h"
#include <string.h>

static void (*mirror_function)(rgbpic_t *) = NULL;

int RGBPIC_PLUGIN_START_FNC(const char *params) {
    if (!strcmp("center", params)) {
        mirror_function = rgbpic_mirror_c;
    } else if (!strcmp("vertical", params)) {
        mirror_function = rgbpic_mirror_v;
    } else if (!strcmp("horizontal", params)) {
        mirror_function = rgbpic_mirror_h;
    } else {
        return 1;
    }
    return 0;
}

rgbpic_t* RGBPIC_PLUGIN_WORK_FNC(rgbpic_t *pic) {
    if (mirror_function) {
        mirror_function(pic);
        return pic;
    }
    return NULL;
}

int RGBPIC_PLUGIN_STOP_FNC() {
    return 0;
}
