#include "pnm.h"
#include <string.h>

static void (*rotate_function)(rgbpic_t *) = NULL;

int RGBPIC_PLUGIN_START_FNC(const char *params) {
    if (!strcmp("left", params) || !strcmp("counterclockwise", params) || !strcmp("+90", params)) {
        rotate_function = rgbpic_rotate_l;
    } else if (!strcmp("right", params) || !strcmp("clockwise", params) || !strcmp("-90", params)) {
        rotate_function = rgbpic_rotate_r;
    } else {
        return 1;
    }
    return 0;
}

rgbpic_t* RGBPIC_PLUGIN_WORK_FNC(rgbpic_t *pic) {
    if (rotate_function) {
        rotate_function(pic);
        return pic;
    }
    return NULL;
}

int RGBPIC_PLUGIN_STOP_FNC() {
    return 0;
}
