#include "pnm.h"
#include <malloc.h>
#include <string.h>

typedef int (*save_fnc_t)(const char*, rgbpic_t*);

static const char *filename = NULL;
static save_fnc_t savefunction = NULL;

struct pnm_t {
    const char * const option;
    const save_fnc_t function;
};

static const struct pnm_t stable[] = {
    {".pbm", rgbpic_save_PBM},
    {".pgm", rgbpic_save_PGM},
    {".ppm", rgbpic_save_PPM},
    {NULL, NULL}
};

int RGBPIC_PLUGIN_START_FNC(const char *params) {
    const char *pnmtype = NULL;
    filename = params;
    for (pnmtype = filename; *pnmtype; ++pnmtype);
    for (--pnmtype; pnmtype > filename; --pnmtype) {
        if (*pnmtype == '.') {
            break;
        }
    }
    if (pnmtype == filename) {
        return 1;
    }
    for (const struct pnm_t *sp = stable; sp->option; ++sp) {
        if (!strcmp(sp->option, pnmtype)) {
            savefunction = sp->function;
            return 0;
        }
    }
    return 1;
}

rgbpic_t* RGBPIC_PLUGIN_WORK_FNC(rgbpic_t *pic) {
    if (savefunction(filename, pic)) {
        return NULL;
    }
    return pic;
}

int RGBPIC_PLUGIN_STOP_FNC() {
    return 0;
}
