#include "pnm.h"
#include <string.h>

static void (*exchange_function)(rgbpic_t *) = NULL;

int RGBPIC_PLUGIN_START_FNC(const char *params) {
    if (!strcmp("red:green", params) || !strcmp("green:red", params)) {
        exchange_function = rgbpic_color_RG;
    } else if (!strcmp("red:blue", params) || !strcmp("blue:red", params)) {
        exchange_function = rgbpic_color_BR;
    } else if (!strcmp("green:blue", params) || !strcmp("blue:green", params)) {
        exchange_function = rgbpic_color_GB;
    } else {
        return 1;
    }
    return 0;
}

rgbpic_t* RGBPIC_PLUGIN_WORK_FNC(rgbpic_t *pic) {
    if (exchange_function) {
        exchange_function(pic);
        return pic;
    }
    return NULL;
}

int RGBPIC_PLUGIN_STOP_FNC() {
    return 0;
}
